#! /usr/bin/bash

run_tests(){

        let "coeff_int=$1" "i=0" "n=$2" "n_t=$3" "thick=0"
        coeff=$(echo "scale=3; $coeff_int/100" | bc -l)

        outfile="./output_data/data.a$coeff.n$n.t$n_t.start$(date +%s).txt"

        while [ $i -lt $n_t ]; do

            #IF THERE IS A COMPLAINT ABOUT NICENESS, COMMENT OUT THE FOLLOWING LINE:

            result=$(./large_graph_tests $coeff $n)

            #AND REPLACE IT WITH THIS ONE:

            #result=$(nice --adjustment=5 ./large_graph_tests $coeff $n)

            let "thick=thick+result"

            let "i++"

        done

        echo "$n $coeff $(echo "scale=2; $thick/$n_t" | bc -l)" >> $outfile
}

echo "How many jobs shall be run simultaneously?"
read cpu_count

let "maxjobs=cpu_count+1"


arg_file="./argument_list.txt"


start_time=$(date +%s)

declare -a ARGUMENTS
declare -a SPAWNONYM

exec 3<"$arg_file"

let "k=0"

while read -r line <&3; do
	ARGUMENTS[k]="$line"
	let "k++"
done

exec 3<&-

let "num_lines=k" "k=0" "actual_spawn=0"

while [ $k -le $((num_lines-2)) ]; do

        #actual_spawn=$(ps -o pid= --ppid $$ | wc -l)
        #let "actual_spawn=actual_spawn-1"

        #if [ $actual_spawn -ge $maxjobs ]; then
        #    let "first_in_batch=k-3*maxjobs+3"
        #    echo "Waiting for PID ${SPAWNONYM[first_in_batch]}"

        #    wait ${SPAWNONYM[first_in_batch]}
        #fi

        until [ $actual_spawn -lt $maxjobs ]; do
            actual_spawn=$(jobs -r | wc -l)
        done

        a=${ARGUMENTS[k]}
        n=${ARGUMENTS[k+1]}
        n_t=${ARGUMENTS[k+2]}

        run_tests $a $n $n_t &
        SPAWNONYM[k]=$!
        actual_spawn=$(jobs -r | wc -l)

        #clear
        echo "(a,n,Tests)=($a,$n,$n_t) started, PID = ${SPAWNONYM[k]}."
        echo "$actual_spawn jobs running."

        let "k=k+3"
done

wait #SEEMS TO BE NEEDED TO AVOID ZOMBIES

end_time=$(date +%s)
let "elapsed=end_time-start_time"
echo "Completed at $(date +%s), after $elapsed seconds."
