#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

using std::vector;

void Genmatrix(long i);
int IsThick(void);
void Squares(void);
bool Union(void);
bool CheckThick(void);
void Cliques(void);
void Nextvert(vector < int >clique);

vector<vector<char> > Adj;
vector<vector<char> > Thick;
int n;
long clq;
int clqtemp;


main(int argc, char *argv[])
{
    n = atoi(argv[1]);

    Adj.resize(n);
    for (int j = 0; j < n; ++j)
	Adj[j].resize(n);

    long count = 0;

    for (long i = 0; i < (long) pow(2.0, n * (n - 1) / 2); i++) {
	Genmatrix(i);
	int add = IsThick();
	count += add;


	if (add == 1) {
	    clqtemp = 0;
	    Cliques();
	    clq += clqtemp;
	}
    }

    printf("There are %ld thick graphs with %d vertices\n", count, n);
    printf("There are %ld cliques\n", clq);
}


void Genmatrix(long i)
{
    for (int j = 0; j < n; j++) {
	for (int k = 0; k < j; k++) {
	    Adj[j][k] = i % 2;
	    Adj[k][j] = Adj[j][k];
	    i = (long) (i - i % 2) / 2;
	}
    }
}

int IsThick()
{
    Squares();

    if (Thick.size() == 0)
	return 0;
    else {
	bool u = true;

	while (u)
	    u = Union();

	if (CheckThick())
	    return 1;
	else
	    return 0;
    }
}



void Squares()
{
    Thick.clear();
    int s = 0;

    for (int i = 0; i < n; i++) {
	for (int j = i + 1; j < n; j++) {
	    if (Adj[i][j] == 1) {
		for (int k = i + 1; k < n; k++) {
		    if (Adj[j][k] == 1 && Adj[i][k] == 0) {
			for (int l = j + 1; l < n; l++) {
			    if (Adj[i][l] == 1 && Adj[k][l] == 1
				&& Adj[j][l] == 0) {
				s++;
				Thick.resize(s);
				Thick[s - 1].resize(n);
				Thick[s - 1][i] = 1;
				Thick[s - 1][j] = 1;
				Thick[s - 1][k] = 1;
				Thick[s - 1][l] = 1;
			    }
			}
		    }
		}
	    }
	}
    }
}



bool Union()
{
    bool u = false;
    int s = Thick.size();

    for (int i = 0; i < n; i++) {
	for (int j = i + 1; j < n; j++) {
	    if (Adj[i][j] == 0) {
		int k = 0;
		int first = -1;

		while (k < s && first == -1) {
		    if (Thick[k][i] == 1 && Thick[k][j] == 1)
			first = k;
		    else
			k++;
		}

		if (first != -1) {
		    for (int p = 0; p < n; p++) {
			if (p != i && p != j && Thick[first][p] == 0
			    && Adj[i][p] == 1 && Adj[j][p] == 1) {
			    u = true;

			    Thick[first][p] = 1;

			}
		    }

		    while (k < s - 1) {
			k++;
			if (Thick[k][i] == 1 && Thick[k][j] == 1) {
			    u = true;
			    for (int p = 0; p < n; p++) {
				if (Thick[k][p] == 1)
				    Thick[first][p] = 1;

				Thick[k][p] = Thick[s - 1][p];


			    }
			    s--;
			}
		    }
		}
	    }
	}
    }

    Thick.resize(s);
    return u;
}






bool CheckThick()
{
    int k = 0;
    int j = 0;

    do {
	if (Thick[0][j] == 0)
	    k = 1;
	j++;
    } while (k == 0 && j < n);

    if (k == 0)
	return true;
    else
	return false;

}

void Cliques()
{
    vector < int >clique;

    for (int j = 0; j < n; j++) {
	clique.clear();
	clique.push_back(j);
	Nextvert(clique);
    }
}

void Nextvert(vector < int >clique)
{
    int s = clique.size();
    int j = clique[s - 1];

    for (int i = j + 1; i < n; i++) {
	bool u = true;

	for (int p = 0; p < s; p++) {
	    if (Adj[clique[p]][i] == 0)
		u = false;
	}

	if (u) {
	    clique.resize(s);
	    clique.push_back(i);
	    clqtemp++;
	    Nextvert(clique);
	}
    }
}
